diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/he/obss-pd-algorithm.h ns-3.47/src/wifi/model/he/obss-pd-algorithm.h
--- ns-3.46/src/wifi/model/he/obss-pd-algorithm.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/he/obss-pd-algorithm.h	2026-02-16 16:08:49.861230900 -0800
@@ -65,17 +65,17 @@
     /**
      * TracedCallback signature for OBSS_PD reset events.
      *
-     * @param [in] bssColor The BSS color of frame triggering the reset
-     * @param [in] rssiDbm The RSSI (dBm) of frame triggering the reset
+     * @param [in] bssColor The BSS color of the frame triggering the reset
+     * @param [in] rssiDbm The RSSI of the frame triggering the reset
      * @param [in] powerRestricted Whether a TX power restriction is triggered
-     * @param [in] txPowerMaxDbmSiso The SISO TX power restricted level (dBm)
-     * @param [in] txPowerMaxDbmMimo The MIMO TX power restricted level (dBm)
+     * @param [in] txPowerMaxDbmSiso The SISO TX power restricted level
+     * @param [in] txPowerMaxDbmMimo The MIMO TX power restricted level
      */
     typedef void (*ResetTracedCallback)(uint8_t bssColor,
-                                        double rssiDbm,
+                                        dBm_u rssiDbm,
                                         bool powerRestricted,
-                                        double txPowerMaxDbmSiso,
-                                        double txPowerMaxDbmMimo);
+                                        dBm_u txPowerMaxDbmSiso,
+                                        dBm_u txPowerMaxDbmMimo);
 
     /**
      * @param level the current OBSS PD level
@@ -101,7 +101,7 @@
     /**
      * TracedCallback signature for PHY reset events.
      */
-    TracedCallback<uint8_t, double, bool, double, double> m_resetEvent;
+    TracedCallback<uint8_t, dBm_u, bool, dBm_u, dBm_u> m_resetEvent;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/ht/ht-phy.cc ns-3.47/src/wifi/model/ht/ht-phy.cc
--- ns-3.46/src/wifi/model/ht/ht-phy.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/ht/ht-phy.cc	2026-02-16 16:08:49.862231000 -0800
@@ -816,7 +816,7 @@
 uint32_t
 HtPhy::GetMaxPsduSize() const
 {
-    return 65535;
+    return WIFI_PSDU_MAX_LENGTH_HT;
 }
 
 const std::map<MHz_u, WifiChannelListType>&
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/interference-helper.h ns-3.47/src/wifi/model/interference-helper.h
--- ns-3.46/src/wifi/model/interference-helper.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/interference-helper.h	2026-02-16 16:08:49.862231000 -0800
@@ -25,11 +25,6 @@
 class ErrorRateModel;
 
 /**
- * A map of the received power for each band
- */
-using RxPowerWattPerChannelBand = std::map<WifiSpectrumBandInfo, Watt_u>;
-
-/**
  * @ingroup wifi
  * @brief handles interference calculations
  * @brief signal event for a PPDU.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/non-ht/dsss-error-rate-model.cc ns-3.47/src/wifi/model/non-ht/dsss-error-rate-model.cc
--- ns-3.46/src/wifi/model/non-ht/dsss-error-rate-model.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/non-ht/dsss-error-rate-model.cc	2026-02-16 16:08:49.863231000 -0800
@@ -25,8 +25,10 @@
 NS_LOG_COMPONENT_DEFINE("DsssErrorRateModel");
 
 #ifndef HAVE_GSL
-const double DsssErrorRateModel::WLAN_SIR_PERFECT = 10.0;
-const double DsssErrorRateModel::WLAN_SIR_IMPOSSIBLE = 0.1;
+/// Perfect Signal to Interference Ratio
+constexpr double WLAN_SIR_PERFECT = 10.0;
+/// Impossible Signal to Interference Ratio
+constexpr double WLAN_SIR_IMPOSSIBLE = 0.1;
 #endif
 
 double
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/non-ht/dsss-error-rate-model.h ns-3.47/src/wifi/model/non-ht/dsss-error-rate-model.h
--- ns-3.46/src/wifi/model/non-ht/dsss-error-rate-model.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/non-ht/dsss-error-rate-model.h	2026-02-16 16:08:49.863231000 -0800
@@ -110,13 +110,6 @@
 #ifdef HAVE_GSL
     static double SymbolErrorProb16Cck(double e2);  /// equation (18) in Pursley's paper
     static double SymbolErrorProb256Cck(double e1); /// equation (17) in Pursley's paper
-#else
-
-  protected:
-    /// WLAN perfect
-    static const double WLAN_SIR_PERFECT;
-    /// WLAN impossible
-    static const double WLAN_SIR_IMPOSSIBLE;
 #endif
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/non-ht/dsss-phy.cc ns-3.47/src/wifi/model/non-ht/dsss-phy.cc
--- ns-3.46/src/wifi/model/non-ht/dsss-phy.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/non-ht/dsss-phy.cc	2026-02-16 16:08:49.863231000 -0800
@@ -387,7 +387,7 @@
 uint32_t
 DsssPhy::GetMaxPsduSize() const
 {
-    return 4095;
+    return WIFI_PSDU_MAX_LENGTH;
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/non-ht/erp-ofdm-phy.cc ns-3.47/src/wifi/model/non-ht/erp-ofdm-phy.cc
--- ns-3.46/src/wifi/model/non-ht/erp-ofdm-phy.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/non-ht/erp-ofdm-phy.cc	2026-02-16 16:08:49.864230900 -0800
@@ -234,7 +234,7 @@
 uint32_t
 ErpOfdmPhy::GetMaxPsduSize() const
 {
-    return 4095;
+    return WIFI_PSDU_MAX_LENGTH;
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/non-ht/ofdm-phy.cc ns-3.47/src/wifi/model/non-ht/ofdm-phy.cc
--- ns-3.46/src/wifi/model/non-ht/ofdm-phy.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/non-ht/ofdm-phy.cc	2026-02-16 16:08:49.864230900 -0800
@@ -650,7 +650,7 @@
 uint32_t
 OfdmPhy::GetMaxPsduSize() const
 {
-    return 4095;
+    return WIFI_PSDU_MAX_LENGTH;
 }
 
 MHz_u
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/phy-entity.cc ns-3.47/src/wifi/model/phy-entity.cc
--- ns-3.46/src/wifi/model/phy-entity.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/phy-entity.cc	2026-02-16 16:08:49.864230900 -0800
@@ -1326,12 +1326,7 @@
 void
 PhyEntity::SwitchMaybeToCcaBusy(const Ptr<const WifiPpdu> ppdu)
 {
-    // We are here because we have received the first bit of a packet and we are
-    // not going to be able to synchronize on it
-    // In this model, CCA becomes busy when the aggregation of all signals as
-    // tracked by the InterferenceHelper class is higher than the CcaBusyThreshold
-    const auto ccaIndication = GetCcaIndication(ppdu);
-    if (ccaIndication.has_value())
+    if (const auto ccaIndication = GetCcaIndication(ppdu))
     {
         NS_LOG_DEBUG("CCA busy for " << ccaIndication.value().second << " during "
                                      << ccaIndication.value().first.As(Time::S));
@@ -1340,9 +1335,17 @@
                                       {});
         return;
     }
+
     if (ppdu)
     {
-        SwitchMaybeToCcaBusy(nullptr);
+        SwitchMaybeToCcaBusy();
+        return;
+    }
+
+    if (m_wifiPhy->IsStateCcaBusy())
+    {
+        NS_LOG_DEBUG("Update CCA indication to IDLE");
+        m_state->SwitchMaybeToCcaBusy(Seconds(0), WIFI_CHANLIST_PRIMARY, {});
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/phy-entity.h ns-3.47/src/wifi/model/phy-entity.h
--- ns-3.46/src/wifi/model/phy-entity.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/phy-entity.h	2026-02-16 16:08:49.864230900 -0800
@@ -13,6 +13,7 @@
 #define PHY_ENTITY_H
 
 #include "wifi-phy-band.h"
+#include "wifi-phy-common.h"
 #include "wifi-phy-state-helper.h"
 #include "wifi-phy.h"
 #include "wifi-ppdu.h"
@@ -35,18 +36,12 @@
  * @ingroup wifi
  * Declaration of:
  * - ns3::PhyEntity class
- * - ns3::SignalNoiseDbm, ns3::MpduInfo, and ns3::RxSignalInfo structs
  * - ns3::RxPowerWattPerChannelBand typedef
  */
 
 namespace ns3
 {
 
-/**
- * A map of the received power for each band
- */
-using RxPowerWattPerChannelBand = std::map<WifiSpectrumBandInfo, Watt_u>;
-
 class WifiMpdu;
 class WifiPhy;
 class InterferenceHelper;
@@ -401,7 +396,8 @@
      *
      * @param ppdu the incoming PPDU or nullptr for any signal
      */
-    virtual void SwitchMaybeToCcaBusy(const Ptr<const WifiPpdu> ppdu);
+    virtual void SwitchMaybeToCcaBusy(const Ptr<const WifiPpdu> ppdu = nullptr);
+
     /**
      * Notify PHY state helper to switch to CCA busy state,
      *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/rate-control/amrr-wifi-manager.cc ns-3.47/src/wifi/model/rate-control/amrr-wifi-manager.cc
--- ns-3.46/src/wifi/model/rate-control/amrr-wifi-manager.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/rate-control/amrr-wifi-manager.cc	2026-02-16 16:08:49.865231000 -0800
@@ -12,8 +12,6 @@
 #include "ns3/simulator.h"
 #include "ns3/wifi-tx-vector.h"
 
-#define Min(a, b) ((a < b) ? a : b)
-
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/rate-control/aparf-wifi-manager.cc ns-3.47/src/wifi/model/rate-control/aparf-wifi-manager.cc
--- ns-3.46/src/wifi/model/rate-control/aparf-wifi-manager.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/rate-control/aparf-wifi-manager.cc	2026-02-16 16:08:49.865231000 -0800
@@ -13,8 +13,6 @@
 #include "ns3/uinteger.h"
 #include "ns3/wifi-phy.h"
 
-#define Min(a, b) ((a < b) ? a : b)
-
 namespace ns3
 {
 
@@ -78,14 +76,14 @@
                           MakeUintegerAccessor(&AparfWifiManager::m_powerMax),
                           MakeUintegerChecker<uint32_t>())
             .AddAttribute("PowerDecrementStep",
-                          "Step size for decrement the power.",
+                          "Step size for decrement the power level.",
                           UintegerValue(1),
-                          MakeUintegerAccessor(&AparfWifiManager::m_powerDec),
+                          MakeUintegerAccessor(&AparfWifiManager::m_powerLevelDec),
                           MakeUintegerChecker<uint8_t>())
             .AddAttribute("PowerIncrementStep",
-                          "Step size for increment the power.",
+                          "Step size for increment the power level.",
                           UintegerValue(1),
-                          MakeUintegerAccessor(&AparfWifiManager::m_powerInc),
+                          MakeUintegerAccessor(&AparfWifiManager::m_powerLevelInc),
                           MakeUintegerChecker<uint8_t>())
             .AddAttribute("RateDecrementStep",
                           "Step size for decrement the rate.",
@@ -122,8 +120,7 @@
 AparfWifiManager::SetupPhy(const Ptr<WifiPhy> phy)
 {
     NS_LOG_FUNCTION(this << phy);
-    m_minPower = 0;
-    m_maxPower = phy->GetNTxPower() - 1;
+    m_maxPowerLevel = WIFI_MIN_TX_PWR_LEVEL + phy->GetNTxPowerLevels() - 1;
     WifiRemoteStationManager::SetupPhy(phy);
 }
 
@@ -173,13 +170,13 @@
         station->m_nSupported = GetNSupported(station);
         station->m_rateIndex = station->m_nSupported - 1;
         station->m_prevRateIndex = station->m_nSupported - 1;
-        station->m_powerLevel = m_maxPower;
-        station->m_prevPowerLevel = m_maxPower;
+        station->m_powerLevel = m_maxPowerLevel;
+        station->m_prevPowerLevel = m_maxPowerLevel;
         station->m_critRateIndex = 0;
         WifiMode mode = GetSupported(station, station->m_rateIndex);
         auto channelWidth = GetChannelWidth(station);
         DataRate rate(mode.GetDataRate(channelWidth));
-        const auto power = GetPhy()->GetPower(m_maxPower);
+        const auto power = GetPhy()->GetPower(m_maxPowerLevel);
         m_powerChange(power, power, station->m_state->m_address);
         m_rateChange(rate, rate, station->m_state->m_address);
         station->m_initialized = true;
@@ -219,7 +216,7 @@
         station->m_nFailed = 0;
         station->m_nSuccess = 0;
         station->m_pCount = 0;
-        if (station->m_powerLevel == m_maxPower)
+        if (station->m_powerLevel == m_maxPowerLevel)
         {
             station->m_critRateIndex = station->m_rateIndex;
             if (station->m_rateIndex != 0)
@@ -231,7 +228,7 @@
         else
         {
             NS_LOG_DEBUG("station=" << station << " inc power");
-            station->m_powerLevel += m_powerInc;
+            station->m_powerLevel += m_powerLevelInc;
         }
     }
 }
@@ -286,10 +283,10 @@
         station->m_nFailed = 0;
         if (station->m_rateIndex == (station->m_state->m_operationalRateSet.size() - 1))
         {
-            if (station->m_powerLevel != m_minPower)
+            if (station->m_powerLevel != m_minPowerLevel)
             {
                 NS_LOG_DEBUG("station=" << station << " dec power");
-                station->m_powerLevel -= m_powerDec;
+                station->m_powerLevel -= m_powerLevelDec;
             }
         }
         else
@@ -306,16 +303,16 @@
             {
                 if (station->m_pCount == m_powerMax)
                 {
-                    station->m_powerLevel = m_maxPower;
+                    station->m_powerLevel = m_maxPowerLevel;
                     station->m_rateIndex = station->m_critRateIndex;
                     station->m_pCount = 0;
                     station->m_critRateIndex = 0;
                 }
                 else
                 {
-                    if (station->m_powerLevel != m_minPower)
+                    if (station->m_powerLevel != m_minPowerLevel)
                     {
-                        station->m_powerLevel -= m_powerDec;
+                        station->m_powerLevel -= m_powerLevelDec;
                         station->m_pCount++;
                     }
                 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/rate-control/aparf-wifi-manager.h ns-3.47/src/wifi/model/rate-control/aparf-wifi-manager.h
--- ns-3.46/src/wifi/model/rate-control/aparf-wifi-manager.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/rate-control/aparf-wifi-manager.h	2026-02-16 16:08:49.866231000 -0800
@@ -87,22 +87,22 @@
                             //!< try a new power or rate.
     uint32_t m_failMax;  //!< The minimum number of failed transmissions to try a new power or rate.
     uint32_t m_powerMax; //!< The maximum number of power changes.
-    uint8_t m_powerInc;  //!< Step size for increment the power.
-    uint8_t m_powerDec;  //!< Step size for decrement the power.
-    uint8_t m_rateInc;   //!< Step size for increment the rate.
-    uint8_t m_rateDec;   //!< Step size for decrement the rate.
+    uint8_t m_powerLevelInc; //!< Step size for increment the power level.
+    uint8_t m_powerLevelDec; //!< Step size for decrement the power level.
+    uint8_t m_rateInc;       //!< Step size for increment the rate.
+    uint8_t m_rateDec;       //!< Step size for decrement the rate.
 
     /**
      * Minimal power level.
      * Differently form rate, power levels do not depend on the remote station.
      * The levels depend only on the physical layer of the device.
      */
-    uint8_t m_minPower;
+    uint8_t m_minPowerLevel{WIFI_MIN_TX_PWR_LEVEL};
 
     /**
      * Maximal power level.
      */
-    uint8_t m_maxPower;
+    uint8_t m_maxPowerLevel{WIFI_MIN_TX_PWR_LEVEL};
 
     /**
      * The trace source fired when the transmission power changes.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/rate-control/arf-wifi-manager.cc ns-3.47/src/wifi/model/rate-control/arf-wifi-manager.cc
--- ns-3.46/src/wifi/model/rate-control/arf-wifi-manager.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/rate-control/arf-wifi-manager.cc	2026-02-16 16:08:49.866231000 -0800
@@ -11,8 +11,6 @@
 #include "ns3/log.h"
 #include "ns3/wifi-tx-vector.h"
 
-#define Min(a, b) ((a < b) ? a : b)
-
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/rate-control/cara-wifi-manager.cc ns-3.47/src/wifi/model/rate-control/cara-wifi-manager.cc
--- ns-3.46/src/wifi/model/rate-control/cara-wifi-manager.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/rate-control/cara-wifi-manager.cc	2026-02-16 16:08:49.866231000 -0800
@@ -11,8 +11,6 @@
 #include "ns3/log.h"
 #include "ns3/wifi-tx-vector.h"
 
-#define Min(a, b) ((a < b) ? a : b)
-
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/rate-control/minstrel-wifi-manager.cc ns-3.47/src/wifi/model/rate-control/minstrel-wifi-manager.cc
--- ns-3.46/src/wifi/model/rate-control/minstrel-wifi-manager.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/rate-control/minstrel-wifi-manager.cc	2026-02-16 16:08:49.866231000 -0800
@@ -30,8 +30,6 @@
 #include <iomanip>
 #include <limits>
 
-#define Min(a, b) ((a < b) ? a : b)
-
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/rate-control/onoe-wifi-manager.cc ns-3.47/src/wifi/model/rate-control/onoe-wifi-manager.cc
--- ns-3.46/src/wifi/model/rate-control/onoe-wifi-manager.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/rate-control/onoe-wifi-manager.cc	2026-02-16 16:08:49.867231000 -0800
@@ -12,8 +12,6 @@
 #include "ns3/simulator.h"
 #include "ns3/wifi-tx-vector.h"
 
-#define Min(a, b) ((a < b) ? a : b)
-
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/rate-control/parf-wifi-manager.cc ns-3.47/src/wifi/model/rate-control/parf-wifi-manager.cc
--- ns-3.46/src/wifi/model/rate-control/parf-wifi-manager.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/rate-control/parf-wifi-manager.cc	2026-02-16 16:08:49.867231000 -0800
@@ -13,8 +13,6 @@
 #include "ns3/uinteger.h"
 #include "ns3/wifi-phy.h"
 
-#define Min(a, b) ((a < b) ? a : b)
-
 namespace ns3
 {
 
@@ -88,8 +86,7 @@
 ParfWifiManager::SetupPhy(const Ptr<WifiPhy> phy)
 {
     NS_LOG_FUNCTION(this << phy);
-    m_minPower = 0;
-    m_maxPower = phy->GetNTxPower() - 1;
+    m_maxPowerLevel = WIFI_MIN_TX_PWR_LEVEL + phy->GetNTxPowerLevels() - 1;
     WifiRemoteStationManager::SetupPhy(phy);
 }
 
@@ -140,12 +137,12 @@
         station->m_nSupported = GetNSupported(station);
         station->m_rateIndex = station->m_nSupported - 1;
         station->m_prevRateIndex = station->m_nSupported - 1;
-        station->m_powerLevel = m_maxPower;
-        station->m_prevPowerLevel = m_maxPower;
+        station->m_powerLevel = m_maxPowerLevel;
+        station->m_prevPowerLevel = m_maxPowerLevel;
         WifiMode mode = GetSupported(station, station->m_rateIndex);
         auto channelWidth = GetChannelWidth(station);
         DataRate rate(mode.GetDataRate(channelWidth));
-        const auto power = GetPhy()->GetPower(m_maxPower);
+        const auto power = GetPhy()->GetPower(m_maxPowerLevel);
         m_powerChange(power, power, station->m_state->m_address);
         m_rateChange(rate, rate, station->m_state->m_address);
         station->m_initialized = true;
@@ -202,7 +199,7 @@
         if (station->m_nRetry == 1)
         {
             // need recovery fallback
-            if (station->m_powerLevel < m_maxPower)
+            if (station->m_powerLevel < m_maxPowerLevel)
             {
                 NS_LOG_DEBUG("station=" << station << " inc power");
                 station->m_powerLevel++;
@@ -217,7 +214,7 @@
         if (((station->m_nRetry - 1) % 2) == 1)
         {
             // need normal fallback
-            if (station->m_powerLevel == m_maxPower)
+            if (station->m_powerLevel == m_maxPowerLevel)
             {
                 if (station->m_rateIndex != 0)
                 {
@@ -285,7 +282,7 @@
     else if (station->m_nSuccess == m_successThreshold || station->m_nAttempt == m_attemptThreshold)
     {
         // we are at the maximum rate, we decrease power
-        if (station->m_powerLevel != m_minPower)
+        if (station->m_powerLevel != m_minPowerLevel)
         {
             NS_LOG_DEBUG("station=" << station << " dec power");
             station->m_powerLevel--;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/rate-control/parf-wifi-manager.h ns-3.47/src/wifi/model/rate-control/parf-wifi-manager.h
--- ns-3.46/src/wifi/model/rate-control/parf-wifi-manager.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/rate-control/parf-wifi-manager.h	2026-02-16 16:08:49.867231000 -0800
@@ -80,12 +80,12 @@
      * In contrast to rate, power levels do not depend on the remote station.
      * The levels depend only on the physical layer of the device.
      */
-    uint8_t m_minPower;
+    uint8_t m_minPowerLevel{WIFI_MIN_TX_PWR_LEVEL};
 
     /**
      * Maximal power level.
      */
-    uint8_t m_maxPower;
+    uint8_t m_maxPowerLevel{WIFI_MIN_TX_PWR_LEVEL};
 
     /**
      * The trace source fired when the transmission power changes.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/rate-control/rraa-wifi-manager.cc ns-3.47/src/wifi/model/rate-control/rraa-wifi-manager.cc
--- ns-3.46/src/wifi/model/rate-control/rraa-wifi-manager.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/rate-control/rraa-wifi-manager.cc	2026-02-16 16:08:49.867231000 -0800
@@ -14,8 +14,6 @@
 #include "ns3/wifi-mac.h"
 #include "ns3/wifi-phy.h"
 
-#define Min(a, b) ((a < b) ? a : b)
-
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/rate-control/rrpaa-wifi-manager.cc ns-3.47/src/wifi/model/rate-control/rrpaa-wifi-manager.cc
--- ns-3.46/src/wifi/model/rate-control/rrpaa-wifi-manager.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/rate-control/rrpaa-wifi-manager.cc	2026-02-16 16:08:49.867231000 -0800
@@ -140,9 +140,9 @@
     NS_LOG_FUNCTION(this << phy);
     m_sifs = phy->GetSifs();
     m_difs = m_sifs + 2 * phy->GetSlot();
-    m_nPowerLevels = phy->GetNTxPower();
-    m_maxPowerLevel = m_nPowerLevels - 1;
-    m_minPowerLevel = 0;
+    m_nPowerLevels = phy->GetNTxPowerLevels();
+    m_minPowerLevel = WIFI_MIN_TX_PWR_LEVEL;
+    m_maxPowerLevel = WIFI_MIN_TX_PWR_LEVEL + m_nPowerLevels - 1;
     for (const auto& mode : phy->GetModeList())
     {
         WifiTxVector txVector;
@@ -489,25 +489,34 @@
         (static_cast<double>(station->m_counter + station->m_nFailed) / thresholds.m_ewnd);
     NS_LOG_DEBUG("Best loss prob= " << bploss);
     NS_LOG_DEBUG("Worst loss prob= " << wploss);
+    NS_ASSERT(station->m_powerLevel >= WIFI_MIN_TX_PWR_LEVEL);
     if (bploss >= thresholds.m_mtl)
     {
         if (station->m_powerLevel < m_maxPowerLevel)
         {
             NS_LOG_DEBUG("bploss >= MTL and power < maxPower => Increase Power");
-            station->m_pdTable[station->m_rateIndex][station->m_powerLevel] /= m_gamma;
+            station
+                ->m_pdTable[station->m_rateIndex][station->m_powerLevel - WIFI_MIN_TX_PWR_LEVEL] /=
+                m_gamma;
             NS_LOG_DEBUG("pdTable["
-                         << +station->m_rateIndex << "][" << station->m_powerLevel << "] = "
-                         << station->m_pdTable[station->m_rateIndex][station->m_powerLevel]);
+                         << +station->m_rateIndex << "]["
+                         << station->m_powerLevel - WIFI_MIN_TX_PWR_LEVEL << "] = "
+                         << station->m_pdTable[station->m_rateIndex]
+                                              [station->m_powerLevel - WIFI_MIN_TX_PWR_LEVEL]);
             station->m_powerLevel++;
             ResetCountersBasic(station);
         }
         else if (station->m_rateIndex != 0)
         {
             NS_LOG_DEBUG("bploss >= MTL and power = maxPower => Decrease Rate");
-            station->m_pdTable[station->m_rateIndex][station->m_powerLevel] /= m_gamma;
+            station
+                ->m_pdTable[station->m_rateIndex][station->m_powerLevel - WIFI_MIN_TX_PWR_LEVEL] /=
+                m_gamma;
             NS_LOG_DEBUG("pdTable["
-                         << +station->m_rateIndex << "][" << station->m_powerLevel << "] = "
-                         << station->m_pdTable[station->m_rateIndex][station->m_powerLevel]);
+                         << +station->m_rateIndex << "]["
+                         << +station->m_powerLevel - WIFI_MIN_TX_PWR_LEVEL << "] = "
+                         << station->m_pdTable[station->m_rateIndex]
+                                              [station->m_powerLevel - WIFI_MIN_TX_PWR_LEVEL]);
             station->m_rateIndex--;
             ResetCountersBasic(station);
         }
@@ -525,16 +534,19 @@
             // Recalculate probabilities of lower rates.
             for (uint8_t i = 0; i <= station->m_rateIndex; i++)
             {
-                station->m_pdTable[i][station->m_powerLevel] *= m_delta;
-                if (station->m_pdTable[i][station->m_powerLevel] > 1)
+                station->m_pdTable[i][station->m_powerLevel - WIFI_MIN_TX_PWR_LEVEL] *= m_delta;
+                if (station->m_pdTable[i][station->m_powerLevel - WIFI_MIN_TX_PWR_LEVEL] > 1)
                 {
-                    station->m_pdTable[i][station->m_powerLevel] = 1;
+                    station->m_pdTable[i][station->m_powerLevel - WIFI_MIN_TX_PWR_LEVEL] = 1;
                 }
-                NS_LOG_DEBUG("pdTable[" << i << "][" << (int)station->m_powerLevel
-                                        << "] = " << station->m_pdTable[i][station->m_powerLevel]);
+                NS_LOG_DEBUG(
+                    "pdTable["
+                    << i << "][" << +station->m_powerLevel - WIFI_MIN_TX_PWR_LEVEL << "] = "
+                    << station->m_pdTable[i][station->m_powerLevel - WIFI_MIN_TX_PWR_LEVEL]);
             }
             double rand = m_uniformRandomVariable->GetValue(0, 1);
-            if (rand < station->m_pdTable[station->m_rateIndex + 1][station->m_powerLevel])
+            if (rand < station->m_pdTable[station->m_rateIndex + 1]
+                                         [station->m_powerLevel - WIFI_MIN_TX_PWR_LEVEL])
             {
                 NS_LOG_DEBUG("Increase Rate");
                 station->m_rateIndex++;
@@ -547,16 +559,20 @@
             // Recalculate probabilities of higher powers.
             for (uint32_t i = m_maxPowerLevel; i > station->m_powerLevel; i--)
             {
-                station->m_pdTable[station->m_rateIndex][i] *= m_delta;
-                if (station->m_pdTable[station->m_rateIndex][i] > 1)
+                NS_ASSERT(i >= WIFI_MIN_TX_PWR_LEVEL);
+                station->m_pdTable[station->m_rateIndex][i - WIFI_MIN_TX_PWR_LEVEL] *= m_delta;
+                if (station->m_pdTable[station->m_rateIndex][i - WIFI_MIN_TX_PWR_LEVEL] > 1)
                 {
-                    station->m_pdTable[station->m_rateIndex][i] = 1;
+                    station->m_pdTable[station->m_rateIndex][i - WIFI_MIN_TX_PWR_LEVEL] = 1;
                 }
-                NS_LOG_DEBUG("pdTable[" << +station->m_rateIndex << "][" << i
-                                        << "] = " << station->m_pdTable[station->m_rateIndex][i]);
+                NS_LOG_DEBUG(
+                    "pdTable["
+                    << +station->m_rateIndex << "][" << i << "] = "
+                    << station->m_pdTable[station->m_rateIndex][i - WIFI_MIN_TX_PWR_LEVEL]);
             }
             double rand = m_uniformRandomVariable->GetValue(0, 1);
-            if (rand < station->m_pdTable[station->m_rateIndex][station->m_powerLevel - 1])
+            if (rand < station->m_pdTable[station->m_rateIndex]
+                                         [station->m_powerLevel - WIFI_MIN_TX_PWR_LEVEL])
             {
                 NS_LOG_DEBUG("Decrease Power");
                 station->m_powerLevel--;
@@ -574,16 +590,20 @@
             // Recalculate probabilities of higher powers.
             for (uint32_t i = m_maxPowerLevel; i >= station->m_powerLevel; i--)
             {
-                station->m_pdTable[station->m_rateIndex][i] *= m_delta;
-                if (station->m_pdTable[station->m_rateIndex][i] > 1)
+                NS_ASSERT(i >= WIFI_MIN_TX_PWR_LEVEL);
+                station->m_pdTable[station->m_rateIndex][i - WIFI_MIN_TX_PWR_LEVEL] *= m_delta;
+                if (station->m_pdTable[station->m_rateIndex][i - WIFI_MIN_TX_PWR_LEVEL] > 1)
                 {
-                    station->m_pdTable[station->m_rateIndex][i] = 1;
+                    station->m_pdTable[station->m_rateIndex][i - WIFI_MIN_TX_PWR_LEVEL] = 1;
                 }
-                NS_LOG_DEBUG("pdTable[" << +station->m_rateIndex << "][" << i
-                                        << "] = " << station->m_pdTable[station->m_rateIndex][i]);
+                NS_LOG_DEBUG(
+                    "pdTable["
+                    << +station->m_rateIndex << "][" << i << "] = "
+                    << station->m_pdTable[station->m_rateIndex][i - WIFI_MIN_TX_PWR_LEVEL]);
             }
             double rand = m_uniformRandomVariable->GetValue(0, 1);
-            if (rand < station->m_pdTable[station->m_rateIndex][station->m_powerLevel - 1])
+            if (rand < station->m_pdTable[station->m_rateIndex]
+                                         [station->m_powerLevel - WIFI_MIN_TX_PWR_LEVEL])
             {
                 NS_LOG_DEBUG("Decrease Power");
                 station->m_powerLevel--;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/spectrum-wifi-phy.cc ns-3.47/src/wifi/model/spectrum-wifi-phy.cc
--- ns-3.46/src/wifi/model/spectrum-wifi-phy.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/spectrum-wifi-phy.cc	2026-02-16 16:08:49.868231000 -0800
@@ -601,7 +601,7 @@
                                          rxPowers,
                                          interface ? interface->GetFrequencyRange()
                                                    : GetCurrentFrequencyRange());
-        SwitchMaybeToCcaBusy(nullptr);
+        SwitchMaybeToCcaBusy();
         return;
     }
 
@@ -610,7 +610,7 @@
         NS_LOG_INFO("Received Wi-Fi signal but blocked from syncing");
         NS_ASSERT(interface);
         m_interference->AddForeignSignal(rxDuration, rxPowers, interface->GetFrequencyRange());
-        SwitchMaybeToCcaBusy(nullptr);
+        SwitchMaybeToCcaBusy();
         return;
     }
 
@@ -626,7 +626,7 @@
                             ? " (" + std::to_string(WToDbm(totalRxPower)) + " dBm)"
                             : ""));
         m_interference->Add(ppdu, rxDuration, rxPowers, GetCurrentFrequencyRange());
-        SwitchMaybeToCcaBusy(nullptr);
+        SwitchMaybeToCcaBusy();
         return;
     }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/table-based-error-rate-model.cc ns-3.47/src/wifi/model/table-based-error-rate-model.cc
--- ns-3.46/src/wifi/model/table-based-error-rate-model.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/table-based-error-rate-model.cc	2026-02-16 16:08:49.868231000 -0800
@@ -25,8 +25,8 @@
 namespace ns3
 {
 
-static const double SNR_PRECISION = 2;                         //!< precision for SNR
-static const double TABLED_BASED_ERROR_MODEL_PRECISION = 1e-5; //!< precision for PER
+static const double SNR_PRECISION = 2;                        //!< precision for SNR
+static const double TABLE_BASED_ERROR_MODEL_PRECISION = 1e-5; //!< precision for PER
 
 NS_OBJECT_ENSURE_REGISTERED(TableBasedErrorRateModel);
 
@@ -232,7 +232,7 @@
         per = (1.0 - std::pow((1 - per), (static_cast<double>(size) / tableSize)));
     }
 
-    if (per < TABLED_BASED_ERROR_MODEL_PRECISION)
+    if (per < TABLE_BASED_ERROR_MODEL_PRECISION)
     {
         per = 0.0;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/vht/vht-phy.cc ns-3.47/src/wifi/model/vht/vht-phy.cc
--- ns-3.46/src/wifi/model/vht/vht-phy.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/vht/vht-phy.cc	2026-02-16 16:08:49.869231000 -0800
@@ -520,7 +520,7 @@
 uint32_t
 VhtPhy::GetMaxPsduSize() const
 {
-    return 4692480;
+    return WIFI_PSDU_MAX_LENGTH_VHT;
 }
 
 dBm_u
